[[block]]
struct PushConstants {
    g_num_keys: u32;
    g_bit_shift: u32;
};

[[block]]
struct Keys {
    g_keys: [[stride(4)]] array<i32>;
};

[[block]]
struct GroupHistograms {
    g_group_histograms: [[stride(4)]] array<i32>;
};

var<private> gl_GlobalInvocationID1: vec3<u32>;
var<private> gl_LocalInvocationID1: vec3<u32>;
var<private> gl_WorkGroupID1: vec3<u32>;
var<private> gl_NumWorkGroups1: vec3<u32>;
var<workgroup> lds_histograms: array<atomic<i32>,16u>;

[[group(1), binding(0)]]
var<storage, read_write> var__1: Keys;
[[group(1), binding(1)]]
var<storage, read_write> var__2: GroupHistograms;
[[group(2), binding(0)]]
var<uniform> var__: PushConstants;

fn main1() {
    var gidx: u32;
    var lidx: u32;
    var bidx: u32;
    var num_blocks: u32;
    var block_size: u32;
    var i: i32;
    var key_index: u32;
    var bin_index: i32;

    let e32: u32 = gl_GlobalInvocationID1[0u];
    gidx = e32;
    let e34: u32 = gl_LocalInvocationID1[0u];
    lidx = e34;
    let e36: u32 = gl_WorkGroupID1[0u];
    bidx = e36;
    let e38: u32 = gl_NumWorkGroups1[0u];
    num_blocks = e38;
    block_size = 256u;
    let e39: u32 = lidx;
    if ((e39 < 16u)) {
        let e41: u32 = lidx;
        atomicStore(&lds_histograms[e41], 0);
    }
    workgroupBarrier();
    i = 0;
    loop {
        let e43: i32 = i;
        if ((e43 < 16)) {
            let e45: u32 = gidx;
            let e47: i32 = i;
            key_index = ((e45 * 16u) + bitcast<u32>(e47));
            let e50: u32 = key_index;
            let e52: u32 = var__.g_num_keys;
            if ((e50 >= e52)) {
                break;
            }
            let e54: u32 = key_index;
            let e57: i32 = var__1.g_keys[e54];
            let e59: u32 = var__.g_bit_shift;
            bin_index = ((e57 >> bitcast<u32>(e59)) & 15);
            let e65: i32 = atomicAdd((&lds_histograms[bin_index]), 1);
            let e63: i32 = bin_index;
            continue;
        } else {
            break;
        }
        continuing {
            let e66: i32 = i;
            i = (e66 + 1);
        }
    }
    workgroupBarrier();
    let e68: u32 = lidx;
    if ((e68 < 16u)) {
        let e70: u32 = num_blocks;
        let e71: u32 = lidx;
        let e73: u32 = bidx;
        let e75: u32 = lidx;
        let e77: i32 = atomicLoad(&lds_histograms[e75]);
		var__2.g_group_histograms[((e70 * e71) + e73)] = e77;
    }
    return;
}

[[stage(compute), workgroup_size(256, 1, 1)]]
fn main([[builtin(global_invocation_id)]] gl_GlobalInvocationID: vec3<u32>, [[builtin(local_invocation_id)]] gl_LocalInvocationID: vec3<u32>, [[builtin(workgroup_id)]] gl_WorkGroupID: vec3<u32>, [[builtin(num_workgroups)]] gl_NumWorkGroups: vec3<u32>) {
    gl_GlobalInvocationID1 = gl_GlobalInvocationID;
    gl_LocalInvocationID1 = gl_LocalInvocationID;
    gl_WorkGroupID1 = gl_WorkGroupID;
    gl_NumWorkGroups1 = gl_NumWorkGroups;
    main1();
}
