[[block]]
struct ScannedGroupHistograms {
    g_scanned_group_histograms: [[stride(4)]] array<i32>;
};

[[block]]
struct PushConstants {
    g_num_keys: u32;
    g_bit_shift: u32;
};

[[block]]
struct Keys {
    g_keys: [[stride(4)]] array<i32>;
};

[[block]]
struct Values {
    g_values: [[stride(4)]] array<i32>;
};

[[block]]
struct OutputKeys {
    g_output_keys: [[stride(4)]] array<i32>;
};

[[block]]
struct OutputValues {
    g_output_values: [[stride(4)]] array<i32>;
};

var<private> gl_GlobalInvocationID1: vec3<u32>;
var<private> gl_LocalInvocationID1: vec3<u32>;
var<private> gl_WorkGroupID1: vec3<u32>;
var<private> gl_NumWorkGroups1: vec3<u32>;
var<workgroup> lds_scratch: array<i32,256u>;
var<workgroup> lds_scanned_histogram: array<i32,16u>;

[[group(1), binding(1)]]
var<storage, read_write> var__: ScannedGroupHistograms;
var<workgroup> lds_histogram: array<atomic<i32>,16u>;
[[group(2), binding(0)]]
var<uniform> var__1: PushConstants;
[[group(1), binding(0)]]
var<storage, read_write> var__2: Keys;
[[group(1), binding(3)]]
var<storage, read_write> var__3: Values;
var<workgroup> lds_keys: array<i32,256u>;
[[group(1), binding(2)]]
var<storage, read_write> var__4: OutputKeys;
[[group(1), binding(4)]]
var<storage, read_write> var__5: OutputValues;

fn BlockScanExclusiveAddi1_(key: ptr<function, i32>) -> i32 {
    var gidx: u32;
    var lidx: u32;
    var bidx: u32;
    var num_blocks: u32;
    var block_size: u32;
    var stride: i32;
    var stride1: i32;
    var temp: i32;

    let e49: u32 = gl_GlobalInvocationID1[0u];
    gidx = e49;
    let e51: u32 = gl_LocalInvocationID1[0u];
    lidx = e51;
    let e53: u32 = gl_WorkGroupID1[0u];
    bidx = e53;
    let e55: u32 = gl_NumWorkGroups1[0u];
    num_blocks = e55;
    block_size = 256u;
    let e56: u32 = lidx;
    let e57: i32 = (*key);
    lds_scratch[e56] = e57;
    workgroupBarrier();
    stride = 1;
    loop {
        let e59: i32 = stride;
        if ((e59 < 256)) {
            let e61: u32 = lidx;
            let e62: i32 = stride;
            if ((e61 < bitcast<u32>((256 / (2 * e62))))) {
                let e67: u32 = lidx;
                let e70: i32 = stride;
                let e74: u32 = lidx;
                let e77: i32 = stride;
                let e82: i32 = lds_scratch[(((2u * (e74 + 1u)) * bitcast<u32>(e77)) - 1u)];
                let e83: u32 = lidx;
                let e86: i32 = stride;
                let e91: i32 = lds_scratch[((((2u * e83) + 1u) * bitcast<u32>(e86)) - 1u)];
                lds_scratch[(((2u * (e67 + 1u)) * bitcast<u32>(e70)) - 1u)] = (e82 + e91);
            }
            workgroupBarrier();
            continue;
        } else {
            break;
        }
        continuing {
            let e94: i32 = stride;
            stride = (e94 << bitcast<u32>(1));
        }
    }
    let e97: u32 = lidx;
    if ((e97 == 0u)) {
        lds_scratch[255] = 0;
    }
    workgroupBarrier();
    stride1 = 128;
    loop {
        let e100: i32 = stride1;
        if ((e100 > 0)) {
            let e102: u32 = lidx;
            let e103: i32 = stride1;
            if ((e102 < bitcast<u32>((256 / (2 * e103))))) {
                let e108: u32 = lidx;
                let e111: i32 = stride1;
                let e116: i32 = lds_scratch[((((2u * e108) + 1u) * bitcast<u32>(e111)) - 1u)];
                temp = e116;
                let e117: u32 = lidx;
                let e120: i32 = stride1;
                let e124: u32 = lidx;
                let e127: i32 = stride1;
                let e132: i32 = lds_scratch[(((2u * (e124 + 1u)) * bitcast<u32>(e127)) - 1u)];
                lds_scratch[((((2u * e117) + 1u) * bitcast<u32>(e120)) - 1u)] = e132;
                let e134: u32 = lidx;
                let e137: i32 = stride1;
                let e141: u32 = lidx;
                let e144: i32 = stride1;
                let e149: i32 = lds_scratch[(((2u * (e141 + 1u)) * bitcast<u32>(e144)) - 1u)];
                let e150: i32 = temp;
                lds_scratch[(((2u * (e134 + 1u)) * bitcast<u32>(e137)) - 1u)] = (e149 + e150);
            }
            workgroupBarrier();
            continue;
        } else {
            break;
        }
        continuing {
            let e153: i32 = stride1;
            stride1 = (e153 >> bitcast<u32>(1));
        }
    }
    let e156: u32 = lidx;
    let e158: i32 = lds_scratch[e156];
    return e158;
}

fn main1() {
    var gidx1: u32;
    var lidx1: u32;
    var bidx1: u32;
    var num_blocks1: u32;
    var block_size1: u32;
    var block_start_index: u32;
    var i: i32;
    var key_index: u32;
    var key1: i32;
    var local: i32;
    var value: i32;
    var local1: i32;
    var shift: u32;
    var bin_index: i32;
    var local_histogram: i32;
    var local_histogram_scanned: i32;
    var param: i32;
    var offset: i32;
    var bin_index1: i32;
    var histogram_value: i32;
    var local2: i32;
    var param1: i32;
    var global_offset: i32;
    var local_offset: i32;

    let e64: u32 = gl_GlobalInvocationID1[0u];
    gidx1 = e64;
    let e66: u32 = gl_LocalInvocationID1[0u];
    lidx1 = e66;
    let e68: u32 = gl_WorkGroupID1[0u];
    bidx1 = e68;
    let e70: u32 = gl_NumWorkGroups1[0u];
    num_blocks1 = e70;
    block_size1 = 256u;
    let e71: u32 = lidx1;
    if ((e71 < 16u)) {
        let e73: u32 = lidx1;
        let e74: u32 = num_blocks1;
        let e75: u32 = lidx1;
        let e77: u32 = bidx1;
        let e81: i32 = var__.g_scanned_group_histograms[((e74 * e75) + e77)];
        lds_scanned_histogram[e73] = e81;
    }
    let e83: u32 = bidx1;
    block_start_index = ((e83 * 256u) * 16u);
    i = 0;
    loop {
        let e86: i32 = i;
        if ((e86 < 16)) {
            let e88: u32 = lidx1;
            if ((e88 < 16u)) {
                let e90: u32 = lidx1;
                atomicStore(&lds_histogram[e90], 0);
            }
            let e92: u32 = block_start_index;
            let e93: i32 = i;
            let e97: u32 = lidx1;
            key_index = ((e92 + bitcast<u32>((e93 * 256))) + e97);
            let e99: u32 = key_index;
            let e101: u32 = var__1.g_num_keys;
            if ((e99 < e101)) {
                let e103: u32 = key_index;
                let e106: i32 = var__2.g_keys[e103];
                local = e106;
            } else {
                local = 2147483647;
            }
            let e107: i32 = local;
            key1 = e107;
            let e108: u32 = key_index;
            let e110: u32 = var__1.g_num_keys;
            if ((e108 < e110)) {
                let e112: u32 = key_index;
                let e115: i32 = var__3.g_values[e112];
                local1 = e115;
            } else {
                local1 = 0;
            }
            let e116: i32 = local1;
            value = e116;
            shift = 0u;
            loop {
                let e117: u32 = shift;
                if ((e117 < 4u)) {
                    let e119: i32 = key1;
                    let e121: u32 = var__1.g_bit_shift;
                    let e124: u32 = shift;
                    bin_index = (((e119 >> bitcast<u32>(e121)) >> bitcast<u32>(e124)) & 3);
                    let e128: i32 = bin_index;
                    local_histogram = (1 << bitcast<u32>((e128 * 8)));
                    let e132: i32 = local_histogram;
                    param = e132;
                    let e133: i32 = BlockScanExclusiveAddi1_((&param));
                    local_histogram_scanned = e133;
                    workgroupBarrier();
                    let e134: u32 = lidx1;
                    if ((e134 == 255u)) {
                        let e136: i32 = local_histogram_scanned;
                        let e137: i32 = local_histogram;
                        lds_scratch[0] = (e136 + e137);
                    }
                    workgroupBarrier();
                    let e141: i32 = lds_scratch[0];
                    local_histogram = e141;
                    let e142: i32 = local_histogram;
                    let e145: i32 = local_histogram;
                    let e149: i32 = local_histogram;
                    local_histogram = (((e142 << bitcast<u32>(8)) + (e145 << bitcast<u32>(16))) + (e149 << bitcast<u32>(24)));
                    let e153: i32 = local_histogram;
                    let e154: i32 = local_histogram_scanned;
                    local_histogram_scanned = (e154 + e153);
                    let e156: i32 = local_histogram_scanned;
                    let e157: i32 = bin_index;
                    offset = ((e156 >> bitcast<u32>((e157 * 8))) & 255);
                    let e162: i32 = offset;
                    let e163: i32 = key1;
                    lds_keys[e162] = e163;
                    workgroupBarrier();
                    let e165: u32 = lidx1;
                    let e167: i32 = lds_keys[e165];
                    key1 = e167;
                    workgroupBarrier();
                    let e168: i32 = offset;
                    let e169: i32 = value;
                    lds_keys[e168] = e169;
                    workgroupBarrier();
                    let e171: u32 = lidx1;
                    let e173: i32 = lds_keys[e171];
                    value = e173;
                    workgroupBarrier();
                    continue;
                } else {
                    break;
                }
                continuing {
                    let e174: u32 = shift;
                    shift = (e174 + 2u);
                }
            }
            let e176: i32 = key1;
            let e178: u32 = var__1.g_bit_shift;
            bin_index1 = ((e176 >> bitcast<u32>(e178)) & 15);
            let e184: i32 = atomicAdd(&lds_histogram[bin_index1], 1);
            workgroupBarrier();
            let e182: i32 = bin_index1;
            let e185: u32 = lidx1;
            if ((e185 < 16u)) {
                let e187: u32 = lidx1;
                let e189: i32 = atomicLoad(&lds_histogram[e187]);
                local2 = e189;
            } else {
                local2 = 0;
            }
            let e190: i32 = local2;
            param1 = e190;
            let e191: i32 = BlockScanExclusiveAddi1_((&param1));
            histogram_value = e191;
            let e192: u32 = lidx1;
            if ((e192 < 16u)) {
                let e194: u32 = lidx1;
                let e195: i32 = histogram_value;
                lds_scratch[e194] = e195;
            }
            let e197: i32 = bin_index1;
            let e199: i32 = lds_scanned_histogram[e197];
            global_offset = e199;
            workgroupBarrier();
            let e200: u32 = lidx1;
            let e202: i32 = bin_index1;
            let e204: i32 = lds_scratch[e202];
            local_offset = (bitcast<i32>(e200) - e204);
            let e206: i32 = global_offset;
            let e207: i32 = local_offset;
            let e211: u32 = var__1.g_num_keys;
            if ((bitcast<u32>((e206 + e207)) < e211)) {
                let e213: i32 = global_offset;
                let e214: i32 = local_offset;
                let e216: i32 = key1;
                var__4.g_output_keys[(e213 + e214)] = e216;
                let e219: i32 = global_offset;
                let e220: i32 = local_offset;
                let e222: i32 = value;
                var__5.g_output_values[(e219 + e220)] = e222;
            }
            workgroupBarrier();
            let e225: u32 = lidx1;
            if ((e225 < 16u)) {
                let e227: u32 = lidx1;
                let e228: u32 = lidx1;
                let e230: i32 = atomicLoad(&lds_histogram[e228]);
                let e232: i32 = lds_scanned_histogram[e227];
                lds_scanned_histogram[e227] = (e232 + e230);
            }
            continue;
        } else {
            break;
        }
        continuing {
            let e235: i32 = i;
            i = (e235 + 1);
        }
    }
    return;
}

[[stage(compute), workgroup_size(256, 1, 1)]]
fn main([[builtin(global_invocation_id)]] gl_GlobalInvocationID: vec3<u32>, [[builtin(local_invocation_id)]] gl_LocalInvocationID: vec3<u32>, [[builtin(workgroup_id)]] gl_WorkGroupID: vec3<u32>, [[builtin(num_workgroups)]] gl_NumWorkGroups: vec3<u32>) {
    gl_GlobalInvocationID1 = gl_GlobalInvocationID;
    gl_LocalInvocationID1 = gl_LocalInvocationID;
    gl_WorkGroupID1 = gl_WorkGroupID;
    gl_NumWorkGroups1 = gl_NumWorkGroups;
    main1();
}
