[[block]]
struct PushConstants {
    g_num_keys: u32;
    g_add_sum: u32;
};

[[block]]
struct InputKeys {
    g_input_keys: [[stride(4)]] array<i32>;
};

[[block]]
struct PartSums {
    g_part_sums: [[stride(4)]] array<i32>;
};

[[block]]
struct OutputKeys {
    g_output_keys: [[stride(4)]] array<i32>;
};

var<private> gl_GlobalInvocationID1: vec3<u32>;
var<private> gl_LocalInvocationID1: vec3<u32>;
var<private> gl_WorkGroupID1: vec3<u32>;
var<private> gl_NumWorkGroups1: vec3<u32>;
var<workgroup> lds_keys: array<i32,256u>;
var<workgroup> lds_loads: array<array<i32,256u>,2u>;
[[group(2), binding(0)]]
var<uniform> var__: PushConstants;
[[group(1), binding(0)]]
var<storage, read_write> var__1: InputKeys;
[[group(1), binding(1)]]
var<storage, read_write> var__2: PartSums;
[[group(1), binding(2)]]
var<storage, read_write> var__3: OutputKeys;

fn BlockScanExclusiveAddi1_(key: ptr<function, i32>) -> i32 {
    var gidx: u32;
    var lidx: u32;
    var bidx: u32;
    var num_blocks: u32;
    var block_size: u32;
    var stride: i32;
    var stride1: i32;
    var temp: i32;

    let e36: u32 = gl_GlobalInvocationID1[0u];
    gidx = e36;
    let e38: u32 = gl_LocalInvocationID1[0u];
    lidx = e38;
    let e40: u32 = gl_WorkGroupID1[0u];
    bidx = e40;
    let e42: u32 = gl_NumWorkGroups1[0u];
    num_blocks = e42;
    block_size = 256u;
    let e43: u32 = lidx;
    let e44: i32 = (*key);
    lds_keys[e43] = e44;
    workgroupBarrier();
    stride = 1;
    loop {
        let e46: i32 = stride;
        if ((e46 < 256)) {
            let e48: u32 = lidx;
            let e49: i32 = stride;
            if ((e48 < bitcast<u32>((256 / (2 * e49))))) {
                let e54: u32 = lidx;
                let e57: i32 = stride;
                let e61: u32 = lidx;
                let e64: i32 = stride;
                let e69: i32 = lds_keys[(((2u * (e61 + 1u)) * bitcast<u32>(e64)) - 1u)];
                let e70: u32 = lidx;
                let e73: i32 = stride;
                let e78: i32 = lds_keys[((((2u * e70) + 1u) * bitcast<u32>(e73)) - 1u)];
                lds_keys[(((2u * (e54 + 1u)) * bitcast<u32>(e57)) - 1u)] = (e69 + e78);
            }
            workgroupBarrier();
            continue;
        } else {
            break;
        }
        continuing {
            let e81: i32 = stride;
            stride = (e81 << bitcast<u32>(1));
        }
    }
    let e84: u32 = lidx;
    if ((e84 == 0u)) {
        lds_keys[255] = 0;
    }
    workgroupBarrier();
    stride1 = 128;
    loop {
        let e87: i32 = stride1;
        if ((e87 > 0)) {
            let e89: u32 = lidx;
            let e90: i32 = stride1;
            if ((e89 < bitcast<u32>((256 / (2 * e90))))) {
                let e95: u32 = lidx;
                let e98: i32 = stride1;
                let e103: i32 = lds_keys[((((2u * e95) + 1u) * bitcast<u32>(e98)) - 1u)];
                temp = e103;
                let e104: u32 = lidx;
                let e107: i32 = stride1;
                let e111: u32 = lidx;
                let e114: i32 = stride1;
                let e119: i32 = lds_keys[(((2u * (e111 + 1u)) * bitcast<u32>(e114)) - 1u)];
                lds_keys[((((2u * e104) + 1u) * bitcast<u32>(e107)) - 1u)] = e119;
                let e121: u32 = lidx;
                let e124: i32 = stride1;
                let e128: u32 = lidx;
                let e131: i32 = stride1;
                let e136: i32 = lds_keys[(((2u * (e128 + 1u)) * bitcast<u32>(e131)) - 1u)];
                let e137: i32 = temp;
                lds_keys[(((2u * (e121 + 1u)) * bitcast<u32>(e124)) - 1u)] = (e136 + e137);
            }
            workgroupBarrier();
            continue;
        } else {
            break;
        }
        continuing {
            let e140: i32 = stride1;
            stride1 = (e140 >> bitcast<u32>(1));
        }
    }
    let e143: u32 = lidx;
    let e145: i32 = lds_keys[e143];
    return e145;
}

fn main1() {
    var gidx1: u32;
    var lidx1: u32;
    var bidx1: u32;
    var num_blocks1: u32;
    var block_size1: u32;
    var range_begin: u32;
    var i: u32;
    var load_index: u32;
    var col: u32;
    var row: u32;
    var local: i32;
    var thread_sum: i32;
    var i1: u32;
    var tmp: i32;
    var param: i32;
    var part_sum: i32;
    var local1: i32;
    var i2: u32;
    var i3: u32;
    var store_index: u32;
    var col1: u32;
    var row1: u32;

    let e49: u32 = gl_GlobalInvocationID1[0u];
    gidx1 = e49;
    let e51: u32 = gl_LocalInvocationID1[0u];
    lidx1 = e51;
    let e53: u32 = gl_WorkGroupID1[0u];
    bidx1 = e53;
    let e55: u32 = gl_NumWorkGroups1[0u];
    num_blocks1 = e55;
    block_size1 = 256u;
    let e56: u32 = bidx1;
    let e57: u32 = block_size1;
    range_begin = ((e56 * e57) * 2u);
    i = 0u;
    loop {
        let e60: u32 = i;
        if ((e60 < 2u)) {
            let e62: u32 = range_begin;
            let e63: u32 = i;
            let e64: u32 = block_size1;
            let e67: u32 = lidx1;
            load_index = ((e62 + (e63 * e64)) + e67);
            let e69: u32 = i;
            let e70: u32 = block_size1;
            let e72: u32 = lidx1;
            col = (((e69 * e70) + e72) / 2u);
            let e75: u32 = i;
            let e76: u32 = block_size1;
            let e78: u32 = lidx1;
            row = (((e75 * e76) + e78) % 2u);
            let e81: u32 = row;
            let e82: u32 = col;
            let e83: u32 = load_index;
            let e85: u32 = var__.g_num_keys;
            if ((e83 < e85)) {
                let e87: u32 = load_index;
                let e90: i32 = var__1.g_input_keys[e87];
                local = e90;
            } else {
                local = 0;
            }
            let e91: i32 = local;
            lds_loads[e81][e82] = e91;
            continue;
        } else {
            break;
        }
        continuing {
            let e94: u32 = i;
            i = (e94 + bitcast<u32>(1));
        }
    }
    workgroupBarrier();
    thread_sum = 0;
    i1 = 0u;
    loop {
        let e97: u32 = i1;
        if ((e97 < 2u)) {
            let e99: u32 = i1;
            let e100: u32 = lidx1;
            let e103: i32 = lds_loads[e99][e100];
            tmp = e103;
            let e104: u32 = i1;
            let e105: u32 = lidx1;
            let e106: i32 = thread_sum;
            lds_loads[e104][e105] = e106;
            let e109: i32 = tmp;
            let e110: i32 = thread_sum;
            thread_sum = (e110 + e109);
            continue;
        } else {
            break;
        }
        continuing {
            let e112: u32 = i1;
            i1 = (e112 + bitcast<u32>(1));
        }
    }
    let e115: i32 = thread_sum;
    param = e115;
    let e116: i32 = BlockScanExclusiveAddi1_((&param));
    thread_sum = e116;
    let e118: u32 = var__.g_add_sum;
    if ((e118 == 1u)) {
        let e120: u32 = bidx1;
        let e123: i32 = var__2.g_part_sums[e120];
        local1 = e123;
    } else {
        local1 = 0;
    }
    let e124: i32 = local1;
    part_sum = e124;
    i2 = 0u;
    loop {
        let e125: u32 = i2;
        if ((e125 < 2u)) {
            let e127: u32 = i2;
            let e128: u32 = lidx1;
            let e129: i32 = thread_sum;
            let e132: i32 = lds_loads[e127][e128];
            lds_loads[e127][e128] = (e132 + e129);
            continue;
        } else {
            break;
        }
        continuing {
            let e136: u32 = i2;
            i2 = (e136 + bitcast<u32>(1));
        }
    }
    workgroupBarrier();
    i3 = 0u;
    loop {
        let e139: u32 = i3;
        if ((e139 < 2u)) {
            let e141: u32 = range_begin;
            let e142: u32 = i3;
            let e143: u32 = block_size1;
            let e146: u32 = lidx1;
            store_index = ((e141 + (e142 * e143)) + e146);
            let e148: u32 = i3;
            let e149: u32 = block_size1;
            let e151: u32 = lidx1;
            col1 = (((e148 * e149) + e151) / 2u);
            let e154: u32 = i3;
            let e155: u32 = block_size1;
            let e157: u32 = lidx1;
            row1 = (((e154 * e155) + e157) % 2u);
            let e160: u32 = store_index;
            let e162: u32 = var__.g_num_keys;
            if ((e160 < e162)) {
                let e164: u32 = store_index;
                let e165: u32 = row1;
                let e166: u32 = col1;
                let e169: i32 = lds_loads[e165][e166];
                let e170: i32 = part_sum;
                var__3.g_output_keys[e164] = (e169 + e170);
            }
            continue;
        } else {
            break;
        }
        continuing {
            let e174: u32 = i3;
            i3 = (e174 + bitcast<u32>(1));
        }
    }
    return;
}

[[stage(compute), workgroup_size(256, 1, 1)]]
fn main([[builtin(global_invocation_id)]] gl_GlobalInvocationID: vec3<u32>, [[builtin(local_invocation_id)]] gl_LocalInvocationID: vec3<u32>, [[builtin(workgroup_id)]] gl_WorkGroupID: vec3<u32>, [[builtin(num_workgroups)]] gl_NumWorkGroups: vec3<u32>) {
    gl_GlobalInvocationID1 = gl_GlobalInvocationID;
    gl_LocalInvocationID1 = gl_LocalInvocationID;
    gl_WorkGroupID1 = gl_WorkGroupID;
    gl_NumWorkGroups1 = gl_NumWorkGroups;
    main1();
}
