[[block]]
struct PushConstants {
    g_num_keys: u32;
};

[[block]]
struct InputKeys {
    g_input_keys: [[stride(4)]] array<i32>;
};

[[block]]
struct PartSums {
    g_part_sums: [[stride(4)]] array<i32>;
};

var<private> gl_GlobalInvocationID1: vec3<u32>;
var<private> gl_LocalInvocationID1: vec3<u32>;
var<private> gl_WorkGroupID1: vec3<u32>;
var<private> gl_NumWorkGroups1: vec3<u32>;
var<workgroup> lds_keys: array<i32,256u>;
[[group(2), binding(0)]]
var<uniform> var__: PushConstants;
[[group(1), binding(0)]]
var<storage, read_write> var__1: InputKeys;
[[group(1), binding(1)]]
var<storage, read_write> var__2: PartSums;

fn BlockReduceAddi1_(key: ptr<function, i32>) -> i32 {
    var gidx: u32;
    var lidx: u32;
    var bidx: u32;
    var num_blocks: u32;
    var block_size: u32;
    var stride: i32;

    let e31: u32 = gl_GlobalInvocationID1[0u];
    gidx = e31;
    let e33: u32 = gl_LocalInvocationID1[0u];
    lidx = e33;
    let e35: u32 = gl_WorkGroupID1[0u];
    bidx = e35;
    let e37: u32 = gl_NumWorkGroups1[0u];
    num_blocks = e37;
    block_size = 256u;
    let e38: u32 = lidx;
    let e39: i32 = (*key);
    lds_keys[e38] = e39;
    workgroupBarrier();
    stride = 128;
    loop {
        let e41: i32 = stride;
        if ((e41 > 0)) {
            let e43: u32 = lidx;
            let e44: i32 = stride;
            if ((e43 < bitcast<u32>(e44))) {
                let e47: u32 = lidx;
                let e48: u32 = lidx;
                let e49: i32 = stride;
                let e53: i32 = lds_keys[(e48 + bitcast<u32>(e49))];
                let e55: i32 = lds_keys[e47];
                lds_keys[e47] = (e55 + e53);
            }
            workgroupBarrier();
            continue;
        } else {
            break;
        }
        continuing {
            let e58: i32 = stride;
            stride = (e58 >> bitcast<u32>(1));
        }
    }
    let e62: i32 = lds_keys[0];
    return e62;
}

fn main1() {
    var gidx1: u32;
    var lidx1: u32;
    var bidx1: u32;
    var num_blocks1: u32;
    var block_size1: u32;
    var thread_sum: i32;
    var range_begin: u32;
    var i: u32;
    var load_index: u32;
    var local: i32;
    var param: i32;

    let e35: u32 = gl_GlobalInvocationID1[0u];
    gidx1 = e35;
    let e37: u32 = gl_LocalInvocationID1[0u];
    lidx1 = e37;
    let e39: u32 = gl_WorkGroupID1[0u];
    bidx1 = e39;
    let e41: u32 = gl_NumWorkGroups1[0u];
    num_blocks1 = e41;
    block_size1 = 256u;
    thread_sum = 0;
    let e42: u32 = bidx1;
    let e43: u32 = block_size1;
    range_begin = ((e42 * e43) * 2u);
    i = 0u;
    loop {
        let e46: u32 = i;
        if ((e46 < 2u)) {
            let e48: u32 = range_begin;
            let e49: u32 = i;
            let e50: u32 = block_size1;
            let e53: u32 = lidx1;
            load_index = ((e48 + (e49 * e50)) + e53);
            let e55: u32 = load_index;
            let e57: u32 = var__.g_num_keys;
            if ((e55 < e57)) {
                let e59: u32 = load_index;
                let e62: i32 = var__1.g_input_keys[e59];
                local = e62;
            } else {
                local = 0;
            }
            let e63: i32 = local;
            let e64: i32 = thread_sum;
            thread_sum = (e64 + e63);
            continue;
        } else {
            break;
        }
        continuing {
            let e66: u32 = i;
            i = (e66 + bitcast<u32>(1));
        }
    }
    let e69: i32 = thread_sum;
    param = e69;
    let e70: i32 = BlockReduceAddi1_((&param));
    thread_sum = e70;
    let e71: u32 = lidx1;
    if ((e71 == 0u)) {
        let e73: u32 = bidx1;
        let e74: i32 = thread_sum;
        var__2.g_part_sums[e73] = e74;
    }
    return;
}

[[stage(compute), workgroup_size(256, 1, 1)]]
fn main([[builtin(global_invocation_id)]] gl_GlobalInvocationID: vec3<u32>, [[builtin(local_invocation_id)]] gl_LocalInvocationID: vec3<u32>, [[builtin(workgroup_id)]] gl_WorkGroupID: vec3<u32>, [[builtin(num_workgroups)]] gl_NumWorkGroups: vec3<u32>) {
    gl_GlobalInvocationID1 = gl_GlobalInvocationID;
    gl_LocalInvocationID1 = gl_LocalInvocationID;
    gl_WorkGroupID1 = gl_WorkGroupID;
    gl_NumWorkGroups1 = gl_NumWorkGroups;
    main1();
}
