#pragma once
#include "context.h"
#include "scan.h"

class RadixSort {
	const Context& _context;
	Kernel _groupHistograms;
	Kernel _scatterKeys;
	PrefixSum _scan;

	uint32_t _lastNumKeys = 0;
	Buffer _pushConstantsBuffer;
public:
	RadixSort(const Context& context, const std::filesystem::path& kernelsPath);

	void run(BufferSubrange inputKeys, BufferSubrange outputKeys,
		BufferSubrange inputValues, BufferSubrange outputValues,
		BufferSubrange scratch, uint32_t numKeys);

	size_t getScratchDataSize(uint32_t size) const;

};