#include "context.h"
#include "kernel.h"
#include "buffer.h"


class PrefixSum {
	const Context& _context;
	Kernel _scanAdd;
	Kernel _reduce;

	uint32_t _lastNumKeys = 0;
	Buffer _pushConstants;
public:
	PrefixSum(const Context& context, const std::filesystem::path& kernelsPath) :
		_context{context},
		_scanAdd(context, kernelsPath / "scan_exclusive_add.wgsl"),
		_reduce(context, kernelsPath / "scan_exclusive_add_group_reduce.wgsl"),
		_pushConstants(context, bufferSubrangeAllignment * 5, wgpu::BufferUsage::Uniform | wgpu::BufferUsage::CopyDst)
	{
		_scanAdd.setBindGroup(0);
		_reduce.setBindGroup(0);
	}

	void run(BufferSubrange input, BufferSubrange output, BufferSubrange scratch, uint32_t num_keys);
	
	size_t getScratchDataSize(uint32_t num_keys) const;

	//static constexpr std::uint32_t num_iterations = 8;
};